using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_CR_ProductCrowdPeriods : EntityBase<T_CR_ProductCrowdPeriods>, ICloneable
    {
        public Guid ProductCrowdPeriodGuid{ get;set; }
        public Guid? ProductCrowdGuid{ get;set; }   
        public Guid? MerchantGuid{ get;set; }   
        public int? CrowdPeriods{ get;set; }   
        public int? TotalTime{ get;set; }   
        public int? RemainTime{ get;set; }   
        public int? BuyTime{ get;set; }   
        public int? Sort{ get;set; }   
        public DateTime? JoinDate{ get;set; }   
        public DateTime? OpenDate{ get;set; }   
        public string Formula{ get;set; }
        public decimal? NumberA{ get;set; }   
        public string PeriodNum{ get;set; }
        public Guid? SMerchantGuid{ get;set; }   
        public int? BuyUnitPrice{ get;set; }   
        
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_CR_ProductCrowdPeriods DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_CR_ProductCrowdPeriods;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_CR_ProductCrowdPeriods ShallowClone()
        {
            return Clone() as T_CR_ProductCrowdPeriods;
        }
        #endregion
        
        #region 实体相互转换
        protected override T_CR_ProductCrowdPeriods CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

